/*
 * Created on 23.06.2005 for PIROL
 *
 * SVN header information:
 *  $Author: LBST-PF-3\orahn $
 *  $Rev: 2446 $
 *  $Date: 2006-09-12 14:57:25 +0200 (Di, 12 Sep 2006) $
 *  $Id: AttributeValue.java 2446 2006-09-12 12:57:25Z LBST-PF-3\orahn $
 */
package de.fhOsnabrueck.jump.pirol.utilities.FormulaParsing.Values;

import com.vividsolutions.jump.feature.Feature;

import de.fhOsnabrueck.jump.pirol.utilities.FormulaParsing.FormulaValue;
import de.fhOsnabrueck.jump.pirol.utilities.comparisonAndSorting.ObjectComparator;

/**
 * Class to extract integer or double values (as double) out of the given Feature...
 *
 * @author Ole Rahn
 * <br>
 * <br>FH Osnabr&uuml;ck - University of Applied Sciences Osnabr&uuml;ck,
 * <br>Project: PIROL (2005),
 * <br>Subproject: Daten- und Wissensmanagement
 * 
 * @version $Rev: 2446 $
 * 
 */
public class AttributeValue extends FormulaValue {
    
    protected String attributeName = "";
    protected int attributeIndex = -1;

    public AttributeValue(String attributeName) {
        super();
        this.attributeName = attributeName;
    }
    
    /**
     * Gets the value (as a double) of the specified attribute out of the given feature.
     *@param feature the Feature we want to get the attribute value from
     *@return value of the specified attribute
     */
    public double getValue(Feature feature) {
        if (this.attributeIndex < 0){
            this.attributeIndex = feature.getSchema().getAttributeIndex(this.attributeName);
        }
        return ObjectComparator.getDoubleValue(feature.getAttribute(this.attributeIndex));
    }

    /**
     * @inheritDoc
     */
    public boolean isFeatureDependent() {
        return true;
    }
    
    /**
     * @inheritDoc
     */
    public String toString(){
        return this.attributeName;
    }

}
